/*
 * NonConvexEnvelopeAction.hpp
 *
 *  Created on: May 10, 2010
 *      Author: heber
 */

#ifndef NONCONVEXENVELOPEACTION_HPP
#define NONCONVEXENVELOPEACTION_HPP

#include "Actions/Action.hpp"


class TesselationListClass;

void TesselationNonConvexEnvelope(double radius, std::string &filename);

class TesselationNonConvexEnvelopeAction : public Action {
  friend void TesselationNonConvexEnvelope(double radius, std::string &filename);

public:
  TesselationNonConvexEnvelopeAction();
  virtual ~TesselationNonConvexEnvelopeAction();

  bool canUndo();
  bool shouldUndo();

  virtual const std::string getName();
protected:
  virtual Dialog * fillDialog(Dialog *dialog);
private:
  virtual void getParametersfromValueStorage();
  virtual Action::state_ptr performCall();
  virtual Action::state_ptr performUndo(Action::state_ptr);
  virtual Action::state_ptr performRedo(Action::state_ptr);

  static const char NAME[];
};


#endif // NONCONVEXENVELOPEACTION_HPP
